// Compiled by ClojureScript 1.10.520 {}
goog.provide('sablono.core');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('goog.string');
goog.require('sablono.normalize');
goog.require('sablono.util');
goog.require('sablono.interpreter');
goog.require('goog.dom');
/**
 * Add an optional attribute argument to a function that returns a element vector.
 */
sablono.core.wrap_attrs = (function sablono$core$wrap_attrs(func){
return (function() { 
var G__33984__delegate = function (args){
if(cljs.core.map_QMARK_.call(null,cljs.core.first.call(null,args))){
var vec__33981 = cljs.core.apply.call(null,func,cljs.core.rest.call(null,args));
var seq__33982 = cljs.core.seq.call(null,vec__33981);
var first__33983 = cljs.core.first.call(null,seq__33982);
var seq__33982__$1 = cljs.core.next.call(null,seq__33982);
var tag = first__33983;
var body = seq__33982__$1;
if(cljs.core.map_QMARK_.call(null,cljs.core.first.call(null,body))){
return cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag,cljs.core.merge.call(null,cljs.core.first.call(null,body),cljs.core.first.call(null,args))], null),cljs.core.rest.call(null,body));
} else {
return cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag,cljs.core.first.call(null,args)], null),body);
}
} else {
return cljs.core.apply.call(null,func,args);
}
};
var G__33984 = function (var_args){
var args = null;
if (arguments.length > 0) {
var G__33985__i = 0, G__33985__a = new Array(arguments.length -  0);
while (G__33985__i < G__33985__a.length) {G__33985__a[G__33985__i] = arguments[G__33985__i + 0]; ++G__33985__i;}
  args = new cljs.core.IndexedSeq(G__33985__a,0,null);
} 
return G__33984__delegate.call(this,args);};
G__33984.cljs$lang$maxFixedArity = 0;
G__33984.cljs$lang$applyTo = (function (arglist__33986){
var args = cljs.core.seq(arglist__33986);
return G__33984__delegate(args);
});
G__33984.cljs$core$IFn$_invoke$arity$variadic = G__33984__delegate;
return G__33984;
})()
;
});
sablono.core.update_arglists = (function sablono$core$update_arglists(arglists){
var iter__4523__auto__ = (function sablono$core$update_arglists_$_iter__33987(s__33988){
return (new cljs.core.LazySeq(null,(function (){
var s__33988__$1 = s__33988;
while(true){
var temp__5720__auto__ = cljs.core.seq.call(null,s__33988__$1);
if(temp__5720__auto__){
var s__33988__$2 = temp__5720__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__33988__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__33988__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__33990 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__33989 = (0);
while(true){
if((i__33989 < size__4522__auto__)){
var args = cljs.core._nth.call(null,c__4521__auto__,i__33989);
cljs.core.chunk_append.call(null,b__33990,cljs.core.vec.call(null,cljs.core.cons.call(null,new cljs.core.Symbol(null,"attr-map?","attr-map?",116307443,null),args)));

var G__33991 = (i__33989 + (1));
i__33989 = G__33991;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__33990),sablono$core$update_arglists_$_iter__33987.call(null,cljs.core.chunk_rest.call(null,s__33988__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__33990),null);
}
} else {
var args = cljs.core.first.call(null,s__33988__$2);
return cljs.core.cons.call(null,cljs.core.vec.call(null,cljs.core.cons.call(null,new cljs.core.Symbol(null,"attr-map?","attr-map?",116307443,null),args)),sablono$core$update_arglists_$_iter__33987.call(null,cljs.core.rest.call(null,s__33988__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4523__auto__.call(null,arglists);
});
/**
 * Include a list of external stylesheet files.
 */
sablono.core.include_css = (function sablono$core$include_css(var_args){
var args__4736__auto__ = [];
var len__4730__auto___33997 = arguments.length;
var i__4731__auto___33998 = (0);
while(true){
if((i__4731__auto___33998 < len__4730__auto___33997)){
args__4736__auto__.push((arguments[i__4731__auto___33998]));

var G__33999 = (i__4731__auto___33998 + (1));
i__4731__auto___33998 = G__33999;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

sablono.core.include_css.cljs$core$IFn$_invoke$arity$variadic = (function (styles){
var iter__4523__auto__ = (function sablono$core$iter__33993(s__33994){
return (new cljs.core.LazySeq(null,(function (){
var s__33994__$1 = s__33994;
while(true){
var temp__5720__auto__ = cljs.core.seq.call(null,s__33994__$1);
if(temp__5720__auto__){
var s__33994__$2 = temp__5720__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__33994__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__33994__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__33996 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__33995 = (0);
while(true){
if((i__33995 < size__4522__auto__)){
var style = cljs.core._nth.call(null,c__4521__auto__,i__33995);
cljs.core.chunk_append.call(null,b__33996,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"link","link",-1769163468),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"text/css",new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,style),new cljs.core.Keyword(null,"rel","rel",1378823488),"stylesheet"], null)], null));

var G__34000 = (i__33995 + (1));
i__33995 = G__34000;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__33996),sablono$core$iter__33993.call(null,cljs.core.chunk_rest.call(null,s__33994__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__33996),null);
}
} else {
var style = cljs.core.first.call(null,s__33994__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"link","link",-1769163468),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"text/css",new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,style),new cljs.core.Keyword(null,"rel","rel",1378823488),"stylesheet"], null)], null),sablono$core$iter__33993.call(null,cljs.core.rest.call(null,s__33994__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4523__auto__.call(null,styles);
});

sablono.core.include_css.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
sablono.core.include_css.cljs$lang$applyTo = (function (seq33992){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq33992));
});

/**
 * Include the JavaScript library at `src`.
 */
sablono.core.include_js = (function sablono$core$include_js(src){
return goog.dom.appendChild(goog.dom.getDocument().body,goog.dom.createDom("script",({"src": src})));
});
/**
 * Include Facebook's React JavaScript library.
 */
sablono.core.include_react = (function sablono$core$include_react(){
return sablono.core.include_js.call(null,"http://fb.me/react-0.12.2.js");
});
/**
 * Wraps some content in a HTML hyperlink with the supplied URL.
 */
sablono.core.link_to34001 = (function sablono$core$link_to34001(var_args){
var args__4736__auto__ = [];
var len__4730__auto___34004 = arguments.length;
var i__4731__auto___34005 = (0);
while(true){
if((i__4731__auto___34005 < len__4730__auto___34004)){
args__4736__auto__.push((arguments[i__4731__auto___34005]));

var G__34006 = (i__4731__auto___34005 + (1));
i__4731__auto___34005 = G__34006;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return sablono.core.link_to34001.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

sablono.core.link_to34001.cljs$core$IFn$_invoke$arity$variadic = (function (url,content){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"a","a",-2123407586),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"href","href",-793805698),sablono.util.as_str.call(null,url)], null),content], null);
});

sablono.core.link_to34001.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
sablono.core.link_to34001.cljs$lang$applyTo = (function (seq34002){
var G__34003 = cljs.core.first.call(null,seq34002);
var seq34002__$1 = cljs.core.next.call(null,seq34002);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__34003,seq34002__$1);
});


sablono.core.link_to = sablono.core.wrap_attrs.call(null,sablono.core.link_to34001);
/**
 * Wraps some content in a HTML hyperlink with the supplied e-mail
 *   address. If no content provided use the e-mail address as content.
 */
sablono.core.mail_to34007 = (function sablono$core$mail_to34007(var_args){
var args__4736__auto__ = [];
var len__4730__auto___34014 = arguments.length;
var i__4731__auto___34015 = (0);
while(true){
if((i__4731__auto___34015 < len__4730__auto___34014)){
args__4736__auto__.push((arguments[i__4731__auto___34015]));

var G__34016 = (i__4731__auto___34015 + (1));
i__4731__auto___34015 = G__34016;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return sablono.core.mail_to34007.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

sablono.core.mail_to34007.cljs$core$IFn$_invoke$arity$variadic = (function (e_mail,p__34010){
var vec__34011 = p__34010;
var content = cljs.core.nth.call(null,vec__34011,(0),null);
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"a","a",-2123407586),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"href","href",-793805698),["mailto:",cljs.core.str.cljs$core$IFn$_invoke$arity$1(e_mail)].join('')], null),(function (){var or__4131__auto__ = content;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return e_mail;
}
})()], null);
});

sablono.core.mail_to34007.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
sablono.core.mail_to34007.cljs$lang$applyTo = (function (seq34008){
var G__34009 = cljs.core.first.call(null,seq34008);
var seq34008__$1 = cljs.core.next.call(null,seq34008);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__34009,seq34008__$1);
});


sablono.core.mail_to = sablono.core.wrap_attrs.call(null,sablono.core.mail_to34007);
/**
 * Wrap a collection in an unordered list.
 */
sablono.core.unordered_list34017 = (function sablono$core$unordered_list34017(coll){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ul","ul",-1349521403),(function (){var iter__4523__auto__ = (function sablono$core$unordered_list34017_$_iter__34018(s__34019){
return (new cljs.core.LazySeq(null,(function (){
var s__34019__$1 = s__34019;
while(true){
var temp__5720__auto__ = cljs.core.seq.call(null,s__34019__$1);
if(temp__5720__auto__){
var s__34019__$2 = temp__5720__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__34019__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__34019__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__34021 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__34020 = (0);
while(true){
if((i__34020 < size__4522__auto__)){
var x = cljs.core._nth.call(null,c__4521__auto__,i__34020);
cljs.core.chunk_append.call(null,b__34021,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null));

var G__34022 = (i__34020 + (1));
i__34020 = G__34022;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__34021),sablono$core$unordered_list34017_$_iter__34018.call(null,cljs.core.chunk_rest.call(null,s__34019__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__34021),null);
}
} else {
var x = cljs.core.first.call(null,s__34019__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null),sablono$core$unordered_list34017_$_iter__34018.call(null,cljs.core.rest.call(null,s__34019__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4523__auto__.call(null,coll);
})()], null);
});

sablono.core.unordered_list = sablono.core.wrap_attrs.call(null,sablono.core.unordered_list34017);
/**
 * Wrap a collection in an ordered list.
 */
sablono.core.ordered_list34023 = (function sablono$core$ordered_list34023(coll){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ol","ol",932524051),(function (){var iter__4523__auto__ = (function sablono$core$ordered_list34023_$_iter__34024(s__34025){
return (new cljs.core.LazySeq(null,(function (){
var s__34025__$1 = s__34025;
while(true){
var temp__5720__auto__ = cljs.core.seq.call(null,s__34025__$1);
if(temp__5720__auto__){
var s__34025__$2 = temp__5720__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__34025__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__34025__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__34027 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__34026 = (0);
while(true){
if((i__34026 < size__4522__auto__)){
var x = cljs.core._nth.call(null,c__4521__auto__,i__34026);
cljs.core.chunk_append.call(null,b__34027,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null));

var G__34028 = (i__34026 + (1));
i__34026 = G__34028;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__34027),sablono$core$ordered_list34023_$_iter__34024.call(null,cljs.core.chunk_rest.call(null,s__34025__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__34027),null);
}
} else {
var x = cljs.core.first.call(null,s__34025__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"li","li",723558921),x], null),sablono$core$ordered_list34023_$_iter__34024.call(null,cljs.core.rest.call(null,s__34025__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4523__auto__.call(null,coll);
})()], null);
});

sablono.core.ordered_list = sablono.core.wrap_attrs.call(null,sablono.core.ordered_list34023);
/**
 * Create an image element.
 */
sablono.core.image34029 = (function sablono$core$image34029(var_args){
var G__34031 = arguments.length;
switch (G__34031) {
case 1:
return sablono.core.image34029.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.image34029.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.image34029.cljs$core$IFn$_invoke$arity$1 = (function (src){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"img","img",1442687358),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"src","src",-1651076051),sablono.util.as_str.call(null,src)], null)], null);
});

sablono.core.image34029.cljs$core$IFn$_invoke$arity$2 = (function (src,alt){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"img","img",1442687358),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"src","src",-1651076051),sablono.util.as_str.call(null,src),new cljs.core.Keyword(null,"alt","alt",-3214426),alt], null)], null);
});

sablono.core.image34029.cljs$lang$maxFixedArity = 2;


sablono.core.image = sablono.core.wrap_attrs.call(null,sablono.core.image34029);
sablono.core._STAR_group_STAR_ = cljs.core.PersistentVector.EMPTY;
/**
 * Create a field name from the supplied argument the current field group.
 */
sablono.core.make_name = (function sablono$core$make_name(name){
return cljs.core.reduce.call(null,(function (p1__34033_SHARP_,p2__34034_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__34033_SHARP_),"[",cljs.core.str.cljs$core$IFn$_invoke$arity$1(p2__34034_SHARP_),"]"].join('');
}),cljs.core.conj.call(null,sablono.core._STAR_group_STAR_,sablono.util.as_str.call(null,name)));
});
/**
 * Create a field id from the supplied argument and current field group.
 */
sablono.core.make_id = (function sablono$core$make_id(name){
return cljs.core.reduce.call(null,(function (p1__34035_SHARP_,p2__34036_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__34035_SHARP_),"-",cljs.core.str.cljs$core$IFn$_invoke$arity$1(p2__34036_SHARP_)].join('');
}),cljs.core.conj.call(null,sablono.core._STAR_group_STAR_,sablono.util.as_str.call(null,name)));
});
/**
 * Creates a new <input> element.
 */
sablono.core.input_field_STAR_ = (function sablono$core$input_field_STAR_(var_args){
var G__34038 = arguments.length;
switch (G__34038) {
case 2:
return sablono.core.input_field_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.input_field_STAR_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.input_field_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (type,name){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),type,new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name)], null)], null);
});

sablono.core.input_field_STAR_.cljs$core$IFn$_invoke$arity$3 = (function (type,name,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),type,new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),(function (){var or__4131__auto__ = value;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return undefined;
}
})()], null)], null);
});

sablono.core.input_field_STAR_.cljs$lang$maxFixedArity = 3;

/**
 * Creates a color input field.
 */
sablono.core.color_field34040 = (function sablono$core$color_field34040(var_args){
var G__34042 = arguments.length;
switch (G__34042) {
case 1:
return sablono.core.color_field34040.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.color_field34040.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.color_field34040.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"color","color",-1642760596,null)),name__33971__auto__);
});

sablono.core.color_field34040.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"color","color",-1642760596,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.color_field34040.cljs$lang$maxFixedArity = 2;


sablono.core.color_field = sablono.core.wrap_attrs.call(null,sablono.core.color_field34040);

/**
 * Creates a date input field.
 */
sablono.core.date_field34043 = (function sablono$core$date_field34043(var_args){
var G__34045 = arguments.length;
switch (G__34045) {
case 1:
return sablono.core.date_field34043.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.date_field34043.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.date_field34043.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"date","date",177097065,null)),name__33971__auto__);
});

sablono.core.date_field34043.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"date","date",177097065,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.date_field34043.cljs$lang$maxFixedArity = 2;


sablono.core.date_field = sablono.core.wrap_attrs.call(null,sablono.core.date_field34043);

/**
 * Creates a datetime input field.
 */
sablono.core.datetime_field34046 = (function sablono$core$datetime_field34046(var_args){
var G__34048 = arguments.length;
switch (G__34048) {
case 1:
return sablono.core.datetime_field34046.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.datetime_field34046.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.datetime_field34046.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"datetime","datetime",2135207229,null)),name__33971__auto__);
});

sablono.core.datetime_field34046.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"datetime","datetime",2135207229,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.datetime_field34046.cljs$lang$maxFixedArity = 2;


sablono.core.datetime_field = sablono.core.wrap_attrs.call(null,sablono.core.datetime_field34046);

/**
 * Creates a datetime-local input field.
 */
sablono.core.datetime_local_field34049 = (function sablono$core$datetime_local_field34049(var_args){
var G__34051 = arguments.length;
switch (G__34051) {
case 1:
return sablono.core.datetime_local_field34049.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.datetime_local_field34049.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.datetime_local_field34049.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"datetime-local","datetime-local",-507312697,null)),name__33971__auto__);
});

sablono.core.datetime_local_field34049.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"datetime-local","datetime-local",-507312697,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.datetime_local_field34049.cljs$lang$maxFixedArity = 2;


sablono.core.datetime_local_field = sablono.core.wrap_attrs.call(null,sablono.core.datetime_local_field34049);

/**
 * Creates a email input field.
 */
sablono.core.email_field34052 = (function sablono$core$email_field34052(var_args){
var G__34054 = arguments.length;
switch (G__34054) {
case 1:
return sablono.core.email_field34052.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.email_field34052.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.email_field34052.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"email","email",-1238619063,null)),name__33971__auto__);
});

sablono.core.email_field34052.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"email","email",-1238619063,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.email_field34052.cljs$lang$maxFixedArity = 2;


sablono.core.email_field = sablono.core.wrap_attrs.call(null,sablono.core.email_field34052);

/**
 * Creates a file input field.
 */
sablono.core.file_field34055 = (function sablono$core$file_field34055(var_args){
var G__34057 = arguments.length;
switch (G__34057) {
case 1:
return sablono.core.file_field34055.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.file_field34055.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.file_field34055.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"file","file",370885649,null)),name__33971__auto__);
});

sablono.core.file_field34055.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"file","file",370885649,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.file_field34055.cljs$lang$maxFixedArity = 2;


sablono.core.file_field = sablono.core.wrap_attrs.call(null,sablono.core.file_field34055);

/**
 * Creates a hidden input field.
 */
sablono.core.hidden_field34058 = (function sablono$core$hidden_field34058(var_args){
var G__34060 = arguments.length;
switch (G__34060) {
case 1:
return sablono.core.hidden_field34058.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.hidden_field34058.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.hidden_field34058.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"hidden","hidden",1328025435,null)),name__33971__auto__);
});

sablono.core.hidden_field34058.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"hidden","hidden",1328025435,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.hidden_field34058.cljs$lang$maxFixedArity = 2;


sablono.core.hidden_field = sablono.core.wrap_attrs.call(null,sablono.core.hidden_field34058);

/**
 * Creates a month input field.
 */
sablono.core.month_field34061 = (function sablono$core$month_field34061(var_args){
var G__34063 = arguments.length;
switch (G__34063) {
case 1:
return sablono.core.month_field34061.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.month_field34061.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.month_field34061.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"month","month",-319717006,null)),name__33971__auto__);
});

sablono.core.month_field34061.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"month","month",-319717006,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.month_field34061.cljs$lang$maxFixedArity = 2;


sablono.core.month_field = sablono.core.wrap_attrs.call(null,sablono.core.month_field34061);

/**
 * Creates a number input field.
 */
sablono.core.number_field34064 = (function sablono$core$number_field34064(var_args){
var G__34066 = arguments.length;
switch (G__34066) {
case 1:
return sablono.core.number_field34064.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.number_field34064.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.number_field34064.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"number","number",-1084057331,null)),name__33971__auto__);
});

sablono.core.number_field34064.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"number","number",-1084057331,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.number_field34064.cljs$lang$maxFixedArity = 2;


sablono.core.number_field = sablono.core.wrap_attrs.call(null,sablono.core.number_field34064);

/**
 * Creates a password input field.
 */
sablono.core.password_field34067 = (function sablono$core$password_field34067(var_args){
var G__34069 = arguments.length;
switch (G__34069) {
case 1:
return sablono.core.password_field34067.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.password_field34067.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.password_field34067.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"password","password",2057553998,null)),name__33971__auto__);
});

sablono.core.password_field34067.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"password","password",2057553998,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.password_field34067.cljs$lang$maxFixedArity = 2;


sablono.core.password_field = sablono.core.wrap_attrs.call(null,sablono.core.password_field34067);

/**
 * Creates a range input field.
 */
sablono.core.range_field34070 = (function sablono$core$range_field34070(var_args){
var G__34072 = arguments.length;
switch (G__34072) {
case 1:
return sablono.core.range_field34070.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.range_field34070.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.range_field34070.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"range","range",-1014743483,null)),name__33971__auto__);
});

sablono.core.range_field34070.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"range","range",-1014743483,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.range_field34070.cljs$lang$maxFixedArity = 2;


sablono.core.range_field = sablono.core.wrap_attrs.call(null,sablono.core.range_field34070);

/**
 * Creates a search input field.
 */
sablono.core.search_field34073 = (function sablono$core$search_field34073(var_args){
var G__34075 = arguments.length;
switch (G__34075) {
case 1:
return sablono.core.search_field34073.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.search_field34073.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.search_field34073.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"search","search",-1089495947,null)),name__33971__auto__);
});

sablono.core.search_field34073.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"search","search",-1089495947,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.search_field34073.cljs$lang$maxFixedArity = 2;


sablono.core.search_field = sablono.core.wrap_attrs.call(null,sablono.core.search_field34073);

/**
 * Creates a tel input field.
 */
sablono.core.tel_field34076 = (function sablono$core$tel_field34076(var_args){
var G__34078 = arguments.length;
switch (G__34078) {
case 1:
return sablono.core.tel_field34076.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.tel_field34076.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.tel_field34076.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"tel","tel",1864669686,null)),name__33971__auto__);
});

sablono.core.tel_field34076.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"tel","tel",1864669686,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.tel_field34076.cljs$lang$maxFixedArity = 2;


sablono.core.tel_field = sablono.core.wrap_attrs.call(null,sablono.core.tel_field34076);

/**
 * Creates a text input field.
 */
sablono.core.text_field34079 = (function sablono$core$text_field34079(var_args){
var G__34081 = arguments.length;
switch (G__34081) {
case 1:
return sablono.core.text_field34079.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.text_field34079.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.text_field34079.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"text","text",-150030170,null)),name__33971__auto__);
});

sablono.core.text_field34079.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"text","text",-150030170,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.text_field34079.cljs$lang$maxFixedArity = 2;


sablono.core.text_field = sablono.core.wrap_attrs.call(null,sablono.core.text_field34079);

/**
 * Creates a time input field.
 */
sablono.core.time_field34082 = (function sablono$core$time_field34082(var_args){
var G__34084 = arguments.length;
switch (G__34084) {
case 1:
return sablono.core.time_field34082.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.time_field34082.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.time_field34082.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"time","time",-1268547887,null)),name__33971__auto__);
});

sablono.core.time_field34082.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"time","time",-1268547887,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.time_field34082.cljs$lang$maxFixedArity = 2;


sablono.core.time_field = sablono.core.wrap_attrs.call(null,sablono.core.time_field34082);

/**
 * Creates a url input field.
 */
sablono.core.url_field34085 = (function sablono$core$url_field34085(var_args){
var G__34087 = arguments.length;
switch (G__34087) {
case 1:
return sablono.core.url_field34085.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.url_field34085.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.url_field34085.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"url","url",1916828573,null)),name__33971__auto__);
});

sablono.core.url_field34085.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"url","url",1916828573,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.url_field34085.cljs$lang$maxFixedArity = 2;


sablono.core.url_field = sablono.core.wrap_attrs.call(null,sablono.core.url_field34085);

/**
 * Creates a week input field.
 */
sablono.core.week_field34088 = (function sablono$core$week_field34088(var_args){
var G__34090 = arguments.length;
switch (G__34090) {
case 1:
return sablono.core.week_field34088.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.week_field34088.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.week_field34088.cljs$core$IFn$_invoke$arity$1 = (function (name__33971__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"week","week",314058249,null)),name__33971__auto__);
});

sablono.core.week_field34088.cljs$core$IFn$_invoke$arity$2 = (function (name__33971__auto__,value__33972__auto__){
return sablono.core.input_field_STAR_.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Symbol(null,"week","week",314058249,null)),name__33971__auto__,value__33972__auto__);
});

sablono.core.week_field34088.cljs$lang$maxFixedArity = 2;


sablono.core.week_field = sablono.core.wrap_attrs.call(null,sablono.core.week_field34088);
sablono.core.file_upload = sablono.core.file_field;
/**
 * Creates a check box.
 */
sablono.core.check_box34108 = (function sablono$core$check_box34108(var_args){
var G__34110 = arguments.length;
switch (G__34110) {
case 1:
return sablono.core.check_box34108.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.check_box34108.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.check_box34108.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.check_box34108.cljs$core$IFn$_invoke$arity$1 = (function (name){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"checkbox",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name)], null)], null);
});

sablono.core.check_box34108.cljs$core$IFn$_invoke$arity$2 = (function (name,checked_QMARK_){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),"checkbox",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.check_box34108.cljs$core$IFn$_invoke$arity$3 = (function (name,checked_QMARK_,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"type","type",1174270348),"checkbox",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),value,new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.check_box34108.cljs$lang$maxFixedArity = 3;


sablono.core.check_box = sablono.core.wrap_attrs.call(null,sablono.core.check_box34108);
/**
 * Creates a radio button.
 */
sablono.core.radio_button34112 = (function sablono$core$radio_button34112(var_args){
var G__34114 = arguments.length;
switch (G__34114) {
case 1:
return sablono.core.radio_button34112.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.radio_button34112.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.radio_button34112.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.radio_button34112.cljs$core$IFn$_invoke$arity$1 = (function (group){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"type","type",1174270348),"radio",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,group),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,sablono.util.as_str.call(null,group))], null)], null);
});

sablono.core.radio_button34112.cljs$core$IFn$_invoke$arity$2 = (function (group,checked_QMARK_){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),"radio",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,group),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,sablono.util.as_str.call(null,group)),new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.radio_button34112.cljs$core$IFn$_invoke$arity$3 = (function (group,checked_QMARK_,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"type","type",1174270348),"radio",new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,group),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(sablono.util.as_str.call(null,group)),"-",cljs.core.str.cljs$core$IFn$_invoke$arity$1(sablono.util.as_str.call(null,value))].join('')),new cljs.core.Keyword(null,"value","value",305978217),value,new cljs.core.Keyword(null,"checked","checked",-50955819),checked_QMARK_], null)], null);
});

sablono.core.radio_button34112.cljs$lang$maxFixedArity = 3;


sablono.core.radio_button = sablono.core.wrap_attrs.call(null,sablono.core.radio_button34112);
sablono.core.hash_key = (function sablono$core$hash_key(x){
return goog.string.hashCode(cljs.core.pr_str.call(null,x));
});
/**
 * Creates a seq of option tags from a collection.
 */
sablono.core.select_options34116 = (function sablono$core$select_options34116(coll){
var iter__4523__auto__ = (function sablono$core$select_options34116_$_iter__34117(s__34118){
return (new cljs.core.LazySeq(null,(function (){
var s__34118__$1 = s__34118;
while(true){
var temp__5720__auto__ = cljs.core.seq.call(null,s__34118__$1);
if(temp__5720__auto__){
var s__34118__$2 = temp__5720__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__34118__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__34118__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__34120 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__34119 = (0);
while(true){
if((i__34119 < size__4522__auto__)){
var x = cljs.core._nth.call(null,c__4521__auto__,i__34119);
cljs.core.chunk_append.call(null,b__34120,((cljs.core.sequential_QMARK_.call(null,x))?(function (){var vec__34121 = x;
var text = cljs.core.nth.call(null,vec__34121,(0),null);
var val = cljs.core.nth.call(null,vec__34121,(1),null);
var disabled_QMARK_ = cljs.core.nth.call(null,vec__34121,(2),null);
var disabled_QMARK___$1 = cljs.core.boolean$.call(null,disabled_QMARK_);
if(cljs.core.sequential_QMARK_.call(null,val)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"optgroup","optgroup",1738282218),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,text),new cljs.core.Keyword(null,"label","label",1718410804),text], null),sablono.core.select_options34116.call(null,val)], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"disabled","disabled",-1529784218),disabled_QMARK___$1,new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,val),new cljs.core.Keyword(null,"value","value",305978217),val], null),text], null);
}
})():new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,x),new cljs.core.Keyword(null,"value","value",305978217),x], null),x], null)));

var G__34127 = (i__34119 + (1));
i__34119 = G__34127;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__34120),sablono$core$select_options34116_$_iter__34117.call(null,cljs.core.chunk_rest.call(null,s__34118__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__34120),null);
}
} else {
var x = cljs.core.first.call(null,s__34118__$2);
return cljs.core.cons.call(null,((cljs.core.sequential_QMARK_.call(null,x))?(function (){var vec__34124 = x;
var text = cljs.core.nth.call(null,vec__34124,(0),null);
var val = cljs.core.nth.call(null,vec__34124,(1),null);
var disabled_QMARK_ = cljs.core.nth.call(null,vec__34124,(2),null);
var disabled_QMARK___$1 = cljs.core.boolean$.call(null,disabled_QMARK_);
if(cljs.core.sequential_QMARK_.call(null,val)){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"optgroup","optgroup",1738282218),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,text),new cljs.core.Keyword(null,"label","label",1718410804),text], null),sablono.core.select_options34116.call(null,val)], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"disabled","disabled",-1529784218),disabled_QMARK___$1,new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,val),new cljs.core.Keyword(null,"value","value",305978217),val], null),text], null);
}
})():new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"option","option",65132272),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"key","key",-1516042587),sablono.core.hash_key.call(null,x),new cljs.core.Keyword(null,"value","value",305978217),x], null),x], null)),sablono$core$select_options34116_$_iter__34117.call(null,cljs.core.rest.call(null,s__34118__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4523__auto__.call(null,coll);
});

sablono.core.select_options = sablono.core.wrap_attrs.call(null,sablono.core.select_options34116);
/**
 * Creates a drop-down box using the <select> tag.
 */
sablono.core.drop_down34128 = (function sablono$core$drop_down34128(var_args){
var G__34130 = arguments.length;
switch (G__34130) {
case 2:
return sablono.core.drop_down34128.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return sablono.core.drop_down34128.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.drop_down34128.cljs$core$IFn$_invoke$arity$2 = (function (name,options){
return sablono.core.drop_down34128.call(null,name,options,null);
});

sablono.core.drop_down34128.cljs$core$IFn$_invoke$arity$3 = (function (name,options,selected){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name)], null),sablono.core.select_options.call(null,options,selected)], null);
});

sablono.core.drop_down34128.cljs$lang$maxFixedArity = 3;


sablono.core.drop_down = sablono.core.wrap_attrs.call(null,sablono.core.drop_down34128);
/**
 * Creates a text area element.
 */
sablono.core.text_area34132 = (function sablono$core$text_area34132(var_args){
var G__34134 = arguments.length;
switch (G__34134) {
case 1:
return sablono.core.text_area34132.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return sablono.core.text_area34132.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

sablono.core.text_area34132.cljs$core$IFn$_invoke$arity$1 = (function (name){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"textarea","textarea",-650375824),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name)], null)], null);
});

sablono.core.text_area34132.cljs$core$IFn$_invoke$arity$2 = (function (name,value){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"textarea","textarea",-650375824),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"name","name",1843675177),sablono.core.make_name.call(null,name),new cljs.core.Keyword(null,"id","id",-1388402092),sablono.core.make_id.call(null,name),new cljs.core.Keyword(null,"value","value",305978217),(function (){var or__4131__auto__ = value;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return undefined;
}
})()], null)], null);
});

sablono.core.text_area34132.cljs$lang$maxFixedArity = 2;


sablono.core.text_area = sablono.core.wrap_attrs.call(null,sablono.core.text_area34132);
/**
 * Creates a label for an input field with the supplied name.
 */
sablono.core.label34136 = (function sablono$core$label34136(name,text){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"label","label",1718410804),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"htmlFor","htmlFor",-1050291720),sablono.core.make_id.call(null,name)], null),text], null);
});

sablono.core.label = sablono.core.wrap_attrs.call(null,sablono.core.label34136);
/**
 * Creates a submit button.
 */
sablono.core.submit_button34137 = (function sablono$core$submit_button34137(text){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),"submit",new cljs.core.Keyword(null,"value","value",305978217),text], null)], null);
});

sablono.core.submit_button = sablono.core.wrap_attrs.call(null,sablono.core.submit_button34137);
/**
 * Creates a form reset button.
 */
sablono.core.reset_button34138 = (function sablono$core$reset_button34138(text){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input","input",556931961),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),"reset",new cljs.core.Keyword(null,"value","value",305978217),text], null)], null);
});

sablono.core.reset_button = sablono.core.wrap_attrs.call(null,sablono.core.reset_button34138);
/**
 * Create a form that points to a particular method and route.
 *   e.g. (form-to [:put "/post"]
 *       ...)
 */
sablono.core.form_to34139 = (function sablono$core$form_to34139(var_args){
var args__4736__auto__ = [];
var len__4730__auto___34146 = arguments.length;
var i__4731__auto___34147 = (0);
while(true){
if((i__4731__auto___34147 < len__4730__auto___34146)){
args__4736__auto__.push((arguments[i__4731__auto___34147]));

var G__34148 = (i__4731__auto___34147 + (1));
i__4731__auto___34147 = G__34148;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return sablono.core.form_to34139.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

sablono.core.form_to34139.cljs$core$IFn$_invoke$arity$variadic = (function (p__34142,body){
var vec__34143 = p__34142;
var method = cljs.core.nth.call(null,vec__34143,(0),null);
var action = cljs.core.nth.call(null,vec__34143,(1),null);
var method_str = clojure.string.upper_case.call(null,cljs.core.name.call(null,method));
var action_uri = sablono.util.to_uri.call(null,action);
return cljs.core.vec.call(null,cljs.core.concat.call(null,((cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"get","get",1683182755),null,new cljs.core.Keyword(null,"post","post",269697687),null], null), null),method))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"form","form",-1624062471),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"method","method",55703592),method_str,new cljs.core.Keyword(null,"action","action",-811238024),action_uri], null)], null):new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"form","form",-1624062471),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"method","method",55703592),"POST",new cljs.core.Keyword(null,"action","action",-811238024),action_uri], null),sablono.core.hidden_field.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"key","key",-1516042587),(3735928559)], null),"_method",method_str)], null)),body));
});

sablono.core.form_to34139.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
sablono.core.form_to34139.cljs$lang$applyTo = (function (seq34140){
var G__34141 = cljs.core.first.call(null,seq34140);
var seq34140__$1 = cljs.core.next.call(null,seq34140);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__34141,seq34140__$1);
});


sablono.core.form_to = sablono.core.wrap_attrs.call(null,sablono.core.form_to34139);
